"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const printImport_1 = __importDefault(require("../../utils/printImport"));
const generateRedirectFileDefault = (params) => {
    const { routeName, destinationDir, importGenerateUrl, patternNamedExports, importRedirectServerSide } = params;
    const functionName = `Redirect${routeName}`;
    const hasPathParams = !!patternNamedExports.pathParamsInterfaceName;
    const template = `${printImport_1.default({ defaultImport: "React", from: "react" })}
  ${printImport_1.default(importRedirectServerSide)}
  ${printImport_1.default(importGenerateUrl)}
  ${printImport_1.default({
        namedImports: [
            { name: patternNamedExports.urlPartsInterfaceName },
            { name: patternNamedExports.patternName },
            { name: patternNamedExports.originName },
        ],
        from: `./${patternNamedExports.filename}`,
    })}
  const ${functionName}: React.FunctionComponent<${patternNamedExports.urlPartsInterfaceName} & { fallback?: React.ReactNode }> = props => {
    const to = generateUrl(${patternNamedExports.patternName}, ${hasPathParams ? "props.path" : "{}"}, props.query, props.origin ?? ${patternNamedExports.originName});
    return <${importRedirectServerSide.defaultImport} href={to} fallback={props.fallback} />;
  };
  export default ${functionName}`;
    return {
        filename: functionName,
        destinationDir,
        extension: ".tsx",
        template,
    };
};
exports.default = generateRedirectFileDefault;
//# sourceMappingURL=generateRedirectFileDefault.js.map