"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const printImport_1 = __importDefault(require("../../utils/printImport"));
const generateUseRedirectFileDefault = (params) => {
    const { routeName, patternNamedExports, destinationDir, importGenerateUrl } = params;
    const functionName = `useRedirect${routeName}`;
    const pathVariable = patternNamedExports.pathParamsInterfaceName ? "urlParts.path" : "{}";
    const resultTypeInterface = `RedirectFn${routeName}`;
    const template = `${printImport_1.default({
        namedImports: [
            { name: patternNamedExports.urlPartsInterfaceName },
            { name: patternNamedExports.patternName },
            { name: patternNamedExports.originName },
        ],
        from: `./${patternNamedExports.filename}`,
    })}
  ${printImport_1.default(importGenerateUrl)}
  export type ${resultTypeInterface} = (urlParts${!patternNamedExports.pathParamsInterfaceName ? "?" : ""}: ${patternNamedExports.urlPartsInterfaceName}) => void;
  const ${functionName} = (): ${resultTypeInterface} => {
    const redirect: ${resultTypeInterface} = urlParts => {
      const to = generateUrl(${patternNamedExports.patternName}, ${pathVariable}, urlParts?.query, urlParts?.origin ?? ${patternNamedExports.originName});
      if (!!window && !!window.location) {
        window.location.href = to;
      }
      return;
    }
    return redirect;
  }
  export default ${functionName}`;
    const templateFile = {
        template,
        filename: functionName,
        extension: ".ts",
        destinationDir,
    };
    return templateFile;
};
exports.default = generateUseRedirectFileDefault;
//# sourceMappingURL=generateUseRedirectFileDefault.js.map