"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const printImport_1 = __importDefault(require("../../utils/printImport"));
const throwError_1 = __importDefault(require("../../utils/throwError"));
const generateUseRedirectFileNextJS = (params) => {
    const { routeName, patternNamedExports: { pathParamsInterfaceName, filename: routePatternFilename, urlPartsInterfaceName, patternNameNextJS, possiblePathParamsVariableName, }, destinationDir, } = params;
    if (!patternNameNextJS) {
        return throwError_1.default([], 'Missing "patternNameNextJS". This is most likely a problem with route-codegen.');
    }
    const functionName = `useRedirect${routeName}`;
    const pathVariable = pathParamsInterfaceName ? "urlParts.path" : "{}";
    const urlPartsModifier = pathParamsInterfaceName ? "" : "?";
    const resultTypeInterface = `RedirectFn${routeName}`;
    let namedImportsFromPatternFile = [{ name: urlPartsInterfaceName }, { name: patternNameNextJS }];
    let pathnameTemplate = `const pathname = ${patternNameNextJS};`;
    if (possiblePathParamsVariableName) {
        namedImportsFromPatternFile.push({ name: possiblePathParamsVariableName });
        pathnameTemplate = `const pathname = ${possiblePathParamsVariableName}.filter((key) => !(key in urlParts.path)).reduce((prevPattern, suppliedParam) => prevPattern.replace(\`/[${"${suppliedParam"}}]\`, ""), ${patternNameNextJS});`;
    }
    const template = `${printImport_1.default({ namedImports: [{ name: "useRouter" }], from: "next/router" })}
  ${printImport_1.default({ namedImports: namedImportsFromPatternFile, from: `./${routePatternFilename}` })}
  export type ${resultTypeInterface} = (urlParts${urlPartsModifier}: ${urlPartsInterfaceName}) => void;
  const ${functionName} = (): ${resultTypeInterface} => {
    const router = useRouter();
    const redirect: ${resultTypeInterface} = urlParts => {
      const query = urlParts?.query ?? {};
      const path = ${pathVariable};
      ${pathnameTemplate}
      router.push({
        pathname: pathname,
        query: {
          ...path,
          ...query,
        },
      })
    }
    return redirect;
  }
  export default ${functionName}`;
    const templateFile = {
        template,
        filename: functionName,
        extension: ".ts",
        destinationDir,
    };
    return templateFile;
};
exports.default = generateUseRedirectFileNextJS;
//# sourceMappingURL=generateUseRedirectFileNextJS.js.map