"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const printImport_1 = __importDefault(require("../../utils/printImport"));
const generateUseParamsFileReactRouterV5 = (params) => {
    const { routeName, destinationDir, patternName, pathParamsInterfaceName, pathParamsFilename } = params;
    const functionName = `useParams${routeName}`;
    const template = `${printImport_1.default({
        namedImports: [{ name: pathParamsInterfaceName }, { name: patternName, importAs: "pattern" }],
        from: `./${pathParamsFilename}`,
    })}
    ${printImport_1.default({
        namedImports: [{ name: "useRouteMatch" }],
        from: "react-router",
    })}
    const ${functionName} = (): ${pathParamsInterfaceName} => {
      const { path, params } = useRouteMatch<${pathParamsInterfaceName}>();
      if (path !== pattern) {
        const error = \`You are trying to use useParams for "${"${pattern}"}" in "${"${path}"}". Make sure you are using the right route link object!\`;
        throw new Error(error);
      }
      return params;
    }
    export default ${functionName};`;
    return {
        template,
        extension: ".ts",
        filename: functionName,
        destinationDir,
    };
};
exports.default = generateUseParamsFileReactRouterV5;
//# sourceMappingURL=generateUseParamsFileReactRouterV5.js.map