"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("./../config");
const generateExternalRoutesConfig = (apps) => {
    const externalRoutesConfig = {};
    Object.entries(apps).forEach(([appName, defaultAppConfig]) => {
        const otherApps = Object.assign({}, apps);
        delete otherApps[appName];
        const appRoutes = Object.entries(otherApps).reduce((prevAppRoutes, [app, { origin = "", routes }]) => {
            if (!routes) {
                return prevAppRoutes;
            }
            const currentAppRoutes = Object.entries(routes).reduce((prevAppRoute, [routeName, route]) => {
                if (typeof route === "string") {
                    prevAppRoute[routeName] = { path: route, origin };
                }
                else if (typeof route === "object") {
                    prevAppRoute[routeName] = { path: route.path, origin: route.origin };
                }
                return prevAppRoute;
            }, {});
            return Object.assign(Object.assign({}, prevAppRoutes), currentAppRoutes);
        }, {});
        externalRoutesConfig[appName] = Object.assign(Object.assign({}, defaultAppConfig), { origin: undefined, routes: appRoutes, routingType: config_1.RoutingType.Default });
    });
    return externalRoutesConfig;
};
exports.default = generateExternalRoutesConfig;
//# sourceMappingURL=generateExternalRoutesConfig.js.map